// Code generated by go-swagger; DO NOT EDIT.

package accounts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAccountUnblockParams creates a new AccountUnblockParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAccountUnblockParams() *AccountUnblockParams {
	return &AccountUnblockParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAccountUnblockParamsWithTimeout creates a new AccountUnblockParams object
// with the ability to set a timeout on a request.
func NewAccountUnblockParamsWithTimeout(timeout time.Duration) *AccountUnblockParams {
	return &AccountUnblockParams{
		timeout: timeout,
	}
}

// NewAccountUnblockParamsWithContext creates a new AccountUnblockParams object
// with the ability to set a context for a request.
func NewAccountUnblockParamsWithContext(ctx context.Context) *AccountUnblockParams {
	return &AccountUnblockParams{
		Context: ctx,
	}
}

// NewAccountUnblockParamsWithHTTPClient creates a new AccountUnblockParams object
// with the ability to set a custom HTTPClient for a request.
func NewAccountUnblockParamsWithHTTPClient(client *http.Client) *AccountUnblockParams {
	return &AccountUnblockParams{
		HTTPClient: client,
	}
}

/*
AccountUnblockParams contains all the parameters to send to the API endpoint

	for the account unblock operation.

	Typically these are written to a http.Request.
*/
type AccountUnblockParams struct {

	/* ID.

	   The id of the account to unblock.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the account unblock params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountUnblockParams) WithDefaults() *AccountUnblockParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the account unblock params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AccountUnblockParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the account unblock params
func (o *AccountUnblockParams) WithTimeout(timeout time.Duration) *AccountUnblockParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the account unblock params
func (o *AccountUnblockParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the account unblock params
func (o *AccountUnblockParams) WithContext(ctx context.Context) *AccountUnblockParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the account unblock params
func (o *AccountUnblockParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the account unblock params
func (o *AccountUnblockParams) WithHTTPClient(client *http.Client) *AccountUnblockParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the account unblock params
func (o *AccountUnblockParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the account unblock params
func (o *AccountUnblockParams) WithID(id string) *AccountUnblockParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the account unblock params
func (o *AccountUnblockParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *AccountUnblockParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
