// Code generated by go-swagger; DO NOT EDIT.

package health

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewLiveHeadParams creates a new LiveHeadParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLiveHeadParams() *LiveHeadParams {
	return &LiveHeadParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLiveHeadParamsWithTimeout creates a new LiveHeadParams object
// with the ability to set a timeout on a request.
func NewLiveHeadParamsWithTimeout(timeout time.Duration) *LiveHeadParams {
	return &LiveHeadParams{
		timeout: timeout,
	}
}

// NewLiveHeadParamsWithContext creates a new LiveHeadParams object
// with the ability to set a context for a request.
func NewLiveHeadParamsWithContext(ctx context.Context) *LiveHeadParams {
	return &LiveHeadParams{
		Context: ctx,
	}
}

// NewLiveHeadParamsWithHTTPClient creates a new LiveHeadParams object
// with the ability to set a custom HTTPClient for a request.
func NewLiveHeadParamsWithHTTPClient(client *http.Client) *LiveHeadParams {
	return &LiveHeadParams{
		HTTPClient: client,
	}
}

/*
LiveHeadParams contains all the parameters to send to the API endpoint

	for the live head operation.

	Typically these are written to a http.Request.
*/
type LiveHeadParams struct {
	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the live head params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LiveHeadParams) WithDefaults() *LiveHeadParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the live head params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LiveHeadParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the live head params
func (o *LiveHeadParams) WithTimeout(timeout time.Duration) *LiveHeadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the live head params
func (o *LiveHeadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the live head params
func (o *LiveHeadParams) WithContext(ctx context.Context) *LiveHeadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the live head params
func (o *LiveHeadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the live head params
func (o *LiveHeadParams) WithHTTPClient(client *http.Client) *LiveHeadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the live head params
func (o *LiveHeadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WriteToRequest writes these params to a swagger request
func (o *LiveHeadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
