// Code generated by go-swagger; DO NOT EDIT.

package notifications

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNotificationParams creates a new NotificationParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNotificationParams() *NotificationParams {
	return &NotificationParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNotificationParamsWithTimeout creates a new NotificationParams object
// with the ability to set a timeout on a request.
func NewNotificationParamsWithTimeout(timeout time.Duration) *NotificationParams {
	return &NotificationParams{
		timeout: timeout,
	}
}

// NewNotificationParamsWithContext creates a new NotificationParams object
// with the ability to set a context for a request.
func NewNotificationParamsWithContext(ctx context.Context) *NotificationParams {
	return &NotificationParams{
		Context: ctx,
	}
}

// NewNotificationParamsWithHTTPClient creates a new NotificationParams object
// with the ability to set a custom HTTPClient for a request.
func NewNotificationParamsWithHTTPClient(client *http.Client) *NotificationParams {
	return &NotificationParams{
		HTTPClient: client,
	}
}

/*
NotificationParams contains all the parameters to send to the API endpoint

	for the notification operation.

	Typically these are written to a http.Request.
*/
type NotificationParams struct {

	/* ID.

	   The ID of the notification.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the notification params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NotificationParams) WithDefaults() *NotificationParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the notification params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NotificationParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the notification params
func (o *NotificationParams) WithTimeout(timeout time.Duration) *NotificationParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the notification params
func (o *NotificationParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the notification params
func (o *NotificationParams) WithContext(ctx context.Context) *NotificationParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the notification params
func (o *NotificationParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the notification params
func (o *NotificationParams) WithHTTPClient(client *http.Client) *NotificationParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the notification params
func (o *NotificationParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the notification params
func (o *NotificationParams) WithID(id string) *NotificationParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the notification params
func (o *NotificationParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *NotificationParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
