// Code generated by go-swagger; DO NOT EDIT.

package polls

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPollParams creates a new PollParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPollParams() *PollParams {
	return &PollParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPollParamsWithTimeout creates a new PollParams object
// with the ability to set a timeout on a request.
func NewPollParamsWithTimeout(timeout time.Duration) *PollParams {
	return &PollParams{
		timeout: timeout,
	}
}

// NewPollParamsWithContext creates a new PollParams object
// with the ability to set a context for a request.
func NewPollParamsWithContext(ctx context.Context) *PollParams {
	return &PollParams{
		Context: ctx,
	}
}

// NewPollParamsWithHTTPClient creates a new PollParams object
// with the ability to set a custom HTTPClient for a request.
func NewPollParamsWithHTTPClient(client *http.Client) *PollParams {
	return &PollParams{
		HTTPClient: client,
	}
}

/*
PollParams contains all the parameters to send to the API endpoint

	for the poll operation.

	Typically these are written to a http.Request.
*/
type PollParams struct {

	/* ID.

	   Target poll ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the poll params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PollParams) WithDefaults() *PollParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the poll params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PollParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the poll params
func (o *PollParams) WithTimeout(timeout time.Duration) *PollParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the poll params
func (o *PollParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the poll params
func (o *PollParams) WithContext(ctx context.Context) *PollParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the poll params
func (o *PollParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the poll params
func (o *PollParams) WithHTTPClient(client *http.Client) *PollParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the poll params
func (o *PollParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the poll params
func (o *PollParams) WithID(id string) *PollParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the poll params
func (o *PollParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PollParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
