// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusDeleteParams creates a new StatusDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusDeleteParams() *StatusDeleteParams {
	return &StatusDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusDeleteParamsWithTimeout creates a new StatusDeleteParams object
// with the ability to set a timeout on a request.
func NewStatusDeleteParamsWithTimeout(timeout time.Duration) *StatusDeleteParams {
	return &StatusDeleteParams{
		timeout: timeout,
	}
}

// NewStatusDeleteParamsWithContext creates a new StatusDeleteParams object
// with the ability to set a context for a request.
func NewStatusDeleteParamsWithContext(ctx context.Context) *StatusDeleteParams {
	return &StatusDeleteParams{
		Context: ctx,
	}
}

// NewStatusDeleteParamsWithHTTPClient creates a new StatusDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusDeleteParamsWithHTTPClient(client *http.Client) *StatusDeleteParams {
	return &StatusDeleteParams{
		HTTPClient: client,
	}
}

/*
StatusDeleteParams contains all the parameters to send to the API endpoint

	for the status delete operation.

	Typically these are written to a http.Request.
*/
type StatusDeleteParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusDeleteParams) WithDefaults() *StatusDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status delete params
func (o *StatusDeleteParams) WithTimeout(timeout time.Duration) *StatusDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status delete params
func (o *StatusDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status delete params
func (o *StatusDeleteParams) WithContext(ctx context.Context) *StatusDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status delete params
func (o *StatusDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status delete params
func (o *StatusDeleteParams) WithHTTPClient(client *http.Client) *StatusDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status delete params
func (o *StatusDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status delete params
func (o *StatusDeleteParams) WithID(id string) *StatusDeleteParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status delete params
func (o *StatusDeleteParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
