// Code generated by go-swagger; DO NOT EDIT.

package statuses

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStatusReblogParams creates a new StatusReblogParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStatusReblogParams() *StatusReblogParams {
	return &StatusReblogParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStatusReblogParamsWithTimeout creates a new StatusReblogParams object
// with the ability to set a timeout on a request.
func NewStatusReblogParamsWithTimeout(timeout time.Duration) *StatusReblogParams {
	return &StatusReblogParams{
		timeout: timeout,
	}
}

// NewStatusReblogParamsWithContext creates a new StatusReblogParams object
// with the ability to set a context for a request.
func NewStatusReblogParamsWithContext(ctx context.Context) *StatusReblogParams {
	return &StatusReblogParams{
		Context: ctx,
	}
}

// NewStatusReblogParamsWithHTTPClient creates a new StatusReblogParams object
// with the ability to set a custom HTTPClient for a request.
func NewStatusReblogParamsWithHTTPClient(client *http.Client) *StatusReblogParams {
	return &StatusReblogParams{
		HTTPClient: client,
	}
}

/*
StatusReblogParams contains all the parameters to send to the API endpoint

	for the status reblog operation.

	Typically these are written to a http.Request.
*/
type StatusReblogParams struct {

	/* ID.

	   Target status ID.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the status reblog params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusReblogParams) WithDefaults() *StatusReblogParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the status reblog params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StatusReblogParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the status reblog params
func (o *StatusReblogParams) WithTimeout(timeout time.Duration) *StatusReblogParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the status reblog params
func (o *StatusReblogParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the status reblog params
func (o *StatusReblogParams) WithContext(ctx context.Context) *StatusReblogParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the status reblog params
func (o *StatusReblogParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the status reblog params
func (o *StatusReblogParams) WithHTTPClient(client *http.Client) *StatusReblogParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the status reblog params
func (o *StatusReblogParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the status reblog params
func (o *StatusReblogParams) WithID(id string) *StatusReblogParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the status reblog params
func (o *StatusReblogParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *StatusReblogParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
